> ## Documentation Index
> Fetch the complete documentation index at: https://docs.ecrypt.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Validate

> ### DESCRIPTION ###



## OpenAPI

````yaml swagger-001.json POST /v1/transactions/validate
openapi: 3.0.4
info:
  title: Ecrypt API
  description: Ecrypt API
  termsOfService: https://ecrypt.com
  contact:
    name: Dev Support
    url: https://developer.ecrypt.com
    email: devsupport@ecrypt.com
  version: v1
servers:
  - url: https://api.ecrypt.com
    description: Live
security:
  - x-api-key: []
paths:
  /v1/transactions/validate:
    post:
      tags:
        - Transactions
      summary: Validate
      description: "### DESCRIPTION ###\r\n***Supported Payment Methods***\r\n- `Credit Card`\r\n- `Cloud EMV`\r\n- `ACH`"
      requestBody:
        description: ''
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.Validate.TransactionValidateRequest
          text/json:
            schema:
              $ref: >-
                #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.Validate.TransactionValidateRequest
          application/*+json:
            schema:
              $ref: >-
                #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.Validate.TransactionValidateRequest
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.TransactionResponse
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Ecrypt.Gateway.Api.Core.Model.BadRequest'
        '401':
          description: Unauthorized
        '403':
          description: Forbidden
        '429':
          description: Too Many Requests
components:
  schemas:
    Ecrypt.Gateway.Api.Core.Model.Transactions.Validate.TransactionValidateRequest:
      required:
        - payment
      type: object
      properties:
        payment:
          $ref: >-
            #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.Payment
        initiatedByUserId:
          type: integer
          format: int64
          nullable: true
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.Transactions.TransactionResponse:
      required:
        - requestId
      type: object
      properties:
        transactionId:
          type: string
        authCode:
          type: string
        responseCode:
          type: string
        responseText:
          type: string
        latency:
          type: integer
          format: int32
        avs:
          $ref: >-
            #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.AvsResponse
        cvv:
          $ref: >-
            #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.CvvResponse
        amount:
          type: number
          format: decimal
        metadata:
          type: object
          additionalProperties: {}
          nullable: true
        requestId:
          maxLength: 100
          minLength: 1
          type: string
          default: '000000000000000000000'
        errors:
          type: array
          items:
            $ref: >-
              #/components/schemas/Ecrypt.Gateway.Api.Core.Model.ResponseBaseError
          nullable: true
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.BadRequest:
      required:
        - requestId
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: '#/components/schemas/Ecrypt.Gateway.Api.Core.Model.BadRequestError'
          nullable: true
        requestId:
          maxLength: 100
          minLength: 1
          type: string
          default: '000000000000000000000'
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.Transactions.Payment:
      type: object
      properties:
        token:
          maxLength: 64
          minLength: 8
          pattern: ^[0-9A-Za-z-]*$
          type: string
          description: "Token ID generated from the iframe or the tokens endpoint.\r\n\r\nExample: 00000000-0000-0000-0000-000000000000"
          nullable: true
        stored:
          $ref: >-
            #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.Stored
        terminal:
          $ref: >-
            #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Terminals.PaymentTerminal
        creditCard:
          $ref: '#/components/schemas/Ecrypt.Gateway.Api.Core.Model.WebAPI.CreditCard'
        check:
          $ref: '#/components/schemas/Ecrypt.Gateway.Api.Core.Model.Check'
        cash:
          type: boolean
          description: ''
          nullable: true
        creditCardEncrypted:
          type: string
          nullable: true
        googlePayPayment:
          $ref: >-
            #/components/schemas/Ecrypt.Gateway.Api.Core.Model.WebAPI.GooglePaymentRequest
        method:
          type: string
          readOnly: true
      additionalProperties: false
      description: "Payment requires that you submit only one of the below options:\r\n- `Token`\r\n- `Stored`\r\n- `Terminal`,\r\n- `Check`\r\n- `Cash`"
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.Transactions.AvsResponse:
      type: object
      properties:
        code:
          type: string
        text:
          type: string
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.Transactions.CvvResponse:
      type: object
      properties:
        code:
          type: string
        text:
          type: string
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.ResponseBaseError:
      type: object
      properties:
        type:
          type: string
        message: {}
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.BadRequestError:
      type: object
      properties:
        type:
          type: string
        message: {}
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.Transactions.Stored:
      type: object
      properties:
        customer:
          maxLength: 64
          minLength: 8
          pattern: ^[0-9A-Za-z-]*$
          type: string
          description: >-
            Ecrypt Customer Identifier, this will use the customers default
            payment method on file.  This can be found under Customer Vault/Api
            User Id
          nullable: true
        wallet:
          maxLength: 64
          minLength: 8
          pattern: ^[0-9A-Za-z-]*$
          type: string
          description: >-
            Ecrypt Customer Wallet Identifier, this will use the specified
            payment method.
          nullable: true
        initiatedBy:
          allOf:
            - $ref: >-
                #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.INITIATED_BY
          nullable: true
        initial:
          allOf:
            - $ref: >-
                #/components/schemas/Ecrypt.Gateway.Api.Core.Model.Transactions.INITIAL
          nullable: true
        installment:
          type: integer
          format: int32
          nullable: true
        initialTransactionId:
          type: string
          nullable: true
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.Terminals.PaymentTerminal:
      required:
        - id
      type: object
      properties:
        id:
          maxLength: 64
          minLength: 8
          pattern: ^[0-9A-Za-z-]*$
          type: string
          description: "Payment Terminal Identifier, this can be found on your Ecrypt Dashboard under Setting/Device Management.\r\n\r\nExample: 00000000-0000-0000-0000-000000000000"
        externalIdentifier:
          type: string
          description: "Processor Terminal Identifier, this is used by the processor.\r\n\r\nINTERNAL USE ONLY"
          nullable: true
        promptTip:
          type: boolean
          description: >-
            Prompt for Tip will display tip at time of sale options.  If your
            account does not support tip at time of sale this option will be
            ignored.
          nullable: true
        tipAmounts:
          type: array
          items:
            type: number
            format: decimal
          description: "Tip amounts in dollar format.  Terminals can support 3 or 4 tip amounts depending on the terminal.  Any extra items will be ignored.  This is required if you set Prompt for Tip to true.\r\n\r\nExample: [28.23, 33.88, 37.65, 41.41]"
          nullable: true
        promptCvv:
          type: boolean
          description: >-
            Prompt for CVV/CVC will attempt to override the card verification
            requirement and force CVV/CVC input.
          nullable: true
        promptPostalCode:
          type: boolean
          description: >-
            Prompt for Postal Code will allow the customer to enter their
            billing postal code.
          nullable: true
        promptAmountConfirmation:
          type: boolean
          description: >-
            Prompt for Amount Confirmation will force the customer to approve
            the transaction amount.
          nullable: true
        promptSignature:
          type: boolean
          description: >-
            Prompt for Signature will show the signature screen on compatible
            terminals.
          nullable: true
        keyCard:
          type: boolean
          description: Prompt Key Card will allow you to manually enter the card details.
          nullable: true
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.WebAPI.CreditCard:
      required:
        - accountNumber
        - expires
      type: object
      properties:
        nameOnCard:
          pattern: ^[0-9A-Za-z `',;-]*$
          type: string
          description: Name as it appears on the credit card.
          default: John Doe
          nullable: true
        accountNumber:
          maxLength: 20
          minLength: 13
          pattern: ^[0-9]*$
          type: string
          description: Credit Card primary account number(PAN)
          default: '4111111111111111'
        expires:
          maxLength: 7
          minLength: 4
          pattern: ^[0-9 /]*$
          type: string
          description: "Credit Card Expiry\r\n\r\nFormat: MMYY\r\nExample: 0135 = January 2035"
          default: '0135'
        verificationValue:
          pattern: ^[0-9]*$
          type: string
          description: 3 or 4 digit card verification value(CVV, CVC).
          default: '000'
          nullable: true
        postalCode:
          pattern: ^[0-9A-Za-z -]*$
          type: string
          description: Billing address postal code.
          default: '90210'
          nullable: true
        transactionId:
          type: string
          description: >-
            Processor transaction id.  This is used for processors that support
            re-charge an existing transaction.  INTERNAL USE ONLY
          nullable: true
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.Check:
      required:
        - accountNumber
        - routingNumber
      type: object
      properties:
        name:
          maxLength: 100
          minLength: 0
          pattern: ^[0-9A-Za-z _\-\.,`'()@#!?\/\\:;|+=@%&]*$
          type: string
          description: "Name as it appears on the check.\r\n\r\nExample: John Doe"
          nullable: true
        accountNumber:
          maxLength: 20
          minLength: 7
          pattern: ^[0-9]*$
          type: string
          description: "Account Number as it appears on the check.\r\n\r\nExample: 123123123"
        routingNumber:
          maxLength: 20
          minLength: 8
          pattern: ^[0-9]*$
          type: string
          description: "Routing Number as it appears on the check.\r\n\r\nExample: 123123123"
        checkNumber:
          maxLength: 8
          minLength: 0
          pattern: ^[0-9]*$
          type: string
          description: "Check Number\r\n\r\nExample: 100"
          nullable: true
        accountType:
          $ref: >-
            #/components/schemas/Ecrypt.Gateway.Api.Core.Model.WebAPI.Enums.AccountType
        verification:
          $ref: '#/components/schemas/Ecrypt.Gateway.Api.Core.Model.CheckVerification'
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.WebAPI.GooglePaymentRequest:
      type: object
      properties:
        signature:
          type: string
        intermediateSigningKey:
          $ref: >-
            #/components/schemas/Ecrypt.Gateway.Api.Core.Model.WebAPI.IntermediateSigningKey
        protocolVersion:
          type: string
        signedMessage:
          type: string
        postalCode:
          type: string
        nameOnCard:
          type: string
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.Transactions.INITIATED_BY:
      enum:
        - 0
        - 1
      type: integer
      description: "Initiated By\r\n\r\nExample: MERCHANT\r\n*** Supported Values ***\r\n- `MERCHANT`, recurring payments, installments, or other senarios where the merchant start then transaction\r\n- `CUSTOMER`, customer started the transaction"
      format: int32
      x-enumNames:
        - MERCHANT
        - CUSTOMER
    Ecrypt.Gateway.Api.Core.Model.Transactions.INITIAL:
      enum:
        - 0
        - 1
      type: integer
      description: "Initial Transaction type\r\n\r\nExample: RECURRING\r\n*** Supported Values ***\r\n- `[NULL]`, \r\n- `RECURRING`\r\n- `INSTALLMENT`"
      format: int32
      x-enumNames:
        - RECURRING
        - INSTALLMENT
    Ecrypt.Gateway.Api.Core.Model.WebAPI.Enums.AccountType:
      enum:
        - 0
        - 1
      type: integer
      description: "Type of account\r\n\r\nExample: CHECKING\r\n*** Supported Values ***\r\n- `CHECKING`\r\n- `SAVINGS`"
      format: int32
      x-enumNames:
        - Checking
        - Savings
    Ecrypt.Gateway.Api.Core.Model.CheckVerification:
      type: object
      properties:
        dob:
          maxLength: 14
          minLength: 8
          pattern: ^[0-9A-Za-z _\-\.\/]*$
          type: string
          description: "Date of Birth\r\n\r\nFormat: MM/DD/YYYY\r\nExample: 01/17/2006 = January 17th 2006"
          nullable: true
        ssn:
          maxLength: 14
          minLength: 8
          pattern: ^[0-9A-Za-z _\-\.\/]*$
          type: string
          description: "Social Security Number\r\n\r\nFormat: DDD-DD-DDDD\r\nExample: 123-45-6789"
          nullable: true
        driversLicense:
          $ref: >-
            #/components/schemas/Ecrypt.Gateway.Api.Core.Model.CheckVerificationDriversLicense
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.WebAPI.IntermediateSigningKey:
      type: object
      properties:
        signedKey:
          type: string
        signatures:
          type: array
          items:
            type: string
          nullable: true
      additionalProperties: false
      nullable: true
    Ecrypt.Gateway.Api.Core.Model.CheckVerificationDriversLicense:
      type: object
      properties:
        number:
          maxLength: 100
          minLength: 0
          pattern: ^[0-9A-Za-z _\-\.\/]*$
          type: string
          description: "Number\r\n\r\nExample: A123456789"
          nullable: true
        state:
          maxLength: 100
          minLength: 0
          pattern: ^[0-9A-Za-z _\-\.\/]*$
          type: string
          description: "State\r\n\r\nFormat: CC\r\nExample: CA = California"
          nullable: true
      additionalProperties: false
      nullable: true
  securitySchemes:
    x-api-key:
      type: apiKey
      description: Authorization by x-api-key inside request's header
      name: x-api-key
      in: header

````